(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('bootstrap-datepicker'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'bootstrap-datepicker', '@angular/common'], factory) :
	(factory((global['ngq-datepicker'] = {}),global.ng.core,global.ng.forms,null,global.ng.common));
}(this, (function (exports,core,forms,bootstrapDatepicker,common) { 'use strict';

var BASE_OPTION = ({ autoclose: true, format: 'dd/mm/yyyy', language: 'en-GB' });
var th_TH = (Object.assign({}, BASE_OPTION, { language: 'th-TH' }));
var en_GB = (Object.assign({}, BASE_OPTION, { language: 'en-GB' }));
var NGQ_DATETIME_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return NgqDatepickerComponent; }),
    multi: true
};
var NgqDatepickerComponent = /** @class */ (function () {
    function NgqDatepickerComponent() {
        this.propagateChange = function (_) { };
        this.onTouched = function () { };
    }
    Object.defineProperty(NgqDatepickerComponent.prototype, "datePickerOptions", {
        set: function (opts) {
            this._datePickerOptions = opts;
            if (this.input) {
                jQuery(this.input.nativeElement).datepicker('destroy');
                var newVal = !!this._date ? new Intl.DateTimeFormat(this._datePickerOptions.language).format(this._date) : '';
                jQuery(this.input.nativeElement).val(newVal);
                this.initDatepicker();
            }
        },
        enumerable: true,
        configurable: true
    });
    NgqDatepickerComponent.prototype.ngAfterViewInit = function () {
        this.initDatepicker();
    };
    NgqDatepickerComponent.prototype.initDatepicker = function () {
        var _this = this;
        if (this.input) {
            this._datepicker = jQuery(this.input.nativeElement).datepicker(this._datePickerOptions);
            this._datepicker.datepicker().on('changeDate', function (e) {
                console.log('changeDate e.date', e.date);
                _this._date = e.date;
                _this.propagateChange(_this._date);
            });
            this._datepicker.datepicker('update', this._date);
            this._datepicker.prop('disabled', this._isDisabled);
        }
    };
    NgqDatepickerComponent.prototype.onChange = function (value) {
        if (!value) {
            this._date = null;
            this.propagateChange(this._date);
        }
        else {
            jQuery(this.input.nativeElement).datepicker('destroy');
            this.initDatepicker();
        }
    };
    NgqDatepickerComponent.prototype.writeValue = function (obj) {
        this._date = obj;
    };
    NgqDatepickerComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    NgqDatepickerComponent.prototype.registerOnTouched = function (fn) { };
    NgqDatepickerComponent.prototype.setDisabledState = function (isDisabled) {
        this._isDisabled = isDisabled;
    };
    return NgqDatepickerComponent;
}());
NgqDatepickerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ngq-datepicker',
                template: "<div *ngIf=\"!hideIcon\" class=\"input-group\">\n  <input #input type=\"text\" [attr.class]=\"class\" [attr.id]=\"id\" [attr.placeholder]=\"placeholder\" (change)=\"onChange($event.target.value)\">\n  <div class=\"input-group-addon\" (click)=\"this._datepicker.datepicker('show')\">\n    <span class=\"glyphicon glyphicon-calendar\"></span>\n  </div>\n</div>\n<input *ngIf=\"hideIcon\" #input type=\"text\" [attr.class]=\"class\" [attr.id]=\"id\" [attr.placeholder]=\"placeholder\">\n",
                styles: [":host{outline:0}"],
                providers: [NGQ_DATETIME_VALUE_ACCESSOR]
            },] },
];
NgqDatepickerComponent.ctorParameters = function () { return []; };
NgqDatepickerComponent.propDecorators = {
    "hideIcon": [{ type: core.Input },],
    "id": [{ type: core.Input },],
    "class": [{ type: core.Input },],
    "placeholder": [{ type: core.Input },],
    "input": [{ type: core.ViewChild, args: ['input',] },],
    "onTouched": [{ type: core.HostListener, args: ['blur',] },],
    "datePickerOptions": [{ type: core.Input, args: ['opts',] },],
};
var NgqDatepickerModule = /** @class */ (function () {
    function NgqDatepickerModule() {
    }
    return NgqDatepickerModule;
}());
NgqDatepickerModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: [NgqDatepickerComponent],
                exports: [NgqDatepickerComponent]
            },] },
];
NgqDatepickerModule.ctorParameters = function () { return []; };

exports.BASE_OPTION = BASE_OPTION;
exports.th_TH = th_TH;
exports.en_GB = en_GB;
exports.NgqDatepickerComponent = NgqDatepickerComponent;
exports.NgqDatepickerModule = NgqDatepickerModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngq-datepicker.umd.js.map
